SKIPMOUNT=false
PROPFILE=false
POSTFSDATA=false
LATESTARTSERVICE=true

REPLACE_EXAMPLE="
/system/app/Youtube
/system/priv-app/SystemUI
/system/priv-app/Settings
/system/framework
"

REPLACE="
"

# Clean up various directories
busybox rm -f /tmp/* 2>/dev/null
busybox rm -f /data/*.log 2>/dev/null
busybox rm -f /cache/*.tmp 2>/dev/null
busybox rm -f /sdcard/LOST.DIR/* 2>/dev/null
busybox rm -f /data/system/usagestats/* 2>/dev/null
busybox rm -f /data/tombstones/* 2>/dev/null
busybox rm -f /data/anr/* 2>/dev/null
rm -f /data/dalvik-cache/*.apk
rm -f /data/dalvik-cache/*.tmp
busybox rm -f /data/system/userbehavior.db

# Mount partitions with specific options
busybox mount -o remount,rw,noatime,noauto_da_alloc,nodiratime,barrier=0,nobh /system
busybox mount -o remount,noatime,noauto_da_alloc,nodiratime,nodev,barrier=0,nobh /data
busybox mount -o remount,noatime,noauto_da_alloc,nodiratime,nodev,barrier=0,nobh /cache

print_modname() {
ui_print "

   _ _____            
  (_) ___/__  _______ 
 / / /__/ _ \/ __/ -_)
/_/\___/\___/_/  \__/ 
                      
"
MODNAME=$(grep_prop name $TMPDIR/module.prop)
    MODVER=$(grep_prop version $TMPDIR/module.prop)
    DV=$(grep_prop author $TMPDIR/module.prop)
    Device=$(getprop ro.product.device)
    Model=$(getprop ro.product.model)
    Brand=$(getprop ro.product.brand)
    Time=$(date "+%d, %b - %H:%M %Z")

    sleep 0.1
    echo "-------------------------------------"
    echo "- Author: $DV"
    echo "- Module: $MODNAME"
    echo "- Version: $MODVER"
    echo "-------------------------------------"
    sleep 0.5
    echo "- Brand: $Brand"
    echo "- Device: $Device"
    echo "- Model: $Model"
    sleep 0.5
    echo "-------------------------------------"
}

on_install() {
  ui_print "- Extracting module files"
  unzip -o "$ZIPFILE" 'system/*' -d $MODPATH >&2
}

set_permissions() {
  # Set permissions recursively
    set_perm_recursive $MODPATH 0 0 0755 0644
    set_perm_recursive $SCRIPT_PATH root root 0777 0755
    set_perm_recursive $MODPATH/tools 0 0 0755 0755
    set_perm_recursive $MODPATH/system 0 0 0755 0755

    # Additional specific permissions
    set_perm_recursive "$MODPATH/system/priv-app/iCore-Ex/iCore.apk" root root 0755 0644
    set_perm_recursive "$MODPATH/system/bin/icore-battery" root root 0755 0755
    set_perm_recursive "$MODPATH/system/bin/icore-default" root root 0755 0755
    set_perm_recursive "$MODPATH/system/bin/icore-game" root root 0755 0755
    set_perm_recursive "$MODPATH/system/bin/icore-multitask" root root 0755 0755
    set_perm_recursive "$MODPATH/system/bin/icore-start" root root 0755 0755
    set_perm_recursive "$MODPATH/system/bin/Dex2oat.sh" root root 0755 0755
set_perm_recursive "$MODPATH/system/bin/doze_clear.sh" root root 0755 0755

    # Display installation progress
    ui_print " [■□□□□□□□□□] 10% "
    sleep 1
    ui_print " [■■□□□□□□□□] 20% "
    sleep 0.5
    ui_print " [■■■□□□□□□□] 30% "
    sleep 1
    ui_print " [■■■■■□□□□□] 50% "
    ui_print " [■■■■■■□□□□] 60% "
    sleep 2
    ui_print " [■■■■■■■□□□] 70% "
    sleep 0.5
    ui_print " [■■■■■■■■□□] 80% "
    ui_print " [■■■■■■■■■□] 90% "
    sleep 3
    ui_print " [■■■■■■■■■■] 100% "
    sleep 1
    echo "-------------------------------------"

    # Perform fstrim on specific partitions
    ui_print "- Trimming up Partitions... "
    fstrim /cache
    sleep 0.2
    fstrim /data
    sleep 0.2
    fstrim /product
    sleep 0.2
    fstrim /system
    sleep 0.2
    fstrim /vendor

    # Wait and finalize installation
    ui_print "- Waiting.... "
    sleep 2
    ui_print "- Ready... "
    ui_print "- Install Successful at $Time !!"
}
