#!/system/bin/sh
for item in `dumpsys deviceidle whitelist`
do
    app=`echo "$item" | cut -f2 -d ','`
    echo "deviceidle whitelist -$app"
    dumpsys deviceidle whitelist -$app
done

echo "Running fstrim for specific paths and optimal storage performance..."

# Run fstrim for specific paths
echo "Running fstrim for /data..."
sudo fstrim /data
echo "Running fstrim for /system..."
sudo fstrim /system
echo "Running fstrim for /cache..."
sudo fstrim /cache

# Check if the fstrim command is available
if command -v fstrim &> /dev/null
then
    # Run fstrim for all mounted filesystems
    sudo fstrim -av
    echo "fstrim completed successfully."
else
    echo "fstrim command not found. Please make sure fstrim is installed on your system."
fi